#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ApiType {
    #[serde(rename = "DOUBLE")]
    Double,
    #[serde(rename = "STRING")]
    String,
    #[serde(rename = "INT64")]
    Int64,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ApiType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ApiType::Double => "DOUBLE",
            ApiType::String => "STRING",
            ApiType::Int64 => "INT64",
            ApiType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ApiType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ApiType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ApiType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<ApiType, conjure_object::plain::ParseEnumError> {
        match v {
            "DOUBLE" => Ok(ApiType::Double),
            "STRING" => Ok(ApiType::String),
            "INT64" => Ok(ApiType::Int64),
            v => v.parse().map(|v| ApiType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ApiType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(v: &str) -> Result<ApiType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ApiType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
